%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 MSBA_product.m
%                   Russell Luke
%                   Max Pentzlin
%                 G-A UniGoettingen
%                  Sept 3, 2010 
%
%
%
%
% DESCRIPTION:  TO DO
% 
%  
%
% INPUT:
%
%     K,mem: dimension variables
%     u_vec, the vector to be multiplied
%     S_mat, the matrix of steps
%     Y_mat, the matrix of gradient differences
%     del,   the initial scaling
%     alpha, a regularization parameter
%
% OUTPUT:
%        
%     v_vec = B*u_vec, where B is the ???? matrix
%
% USAGE: 
%
%       v_vec = MSBA_product(K,mem,u_vec, S_mat, Y_mat, del, alpha)
% 
% SUBROUTINE CALLS:
%      none
%      
%
function v_vec = MSBA_product(K,mem,u_vec, S_mat, Y_mat, del, alpha)

STY_mat=S_mat'*Y_mat; % D^TG in paper
YTY_mat=Y_mat'*Y_mat;% +1e-10*eye(size(STY_mat));
U_mat=Y_mat*((YTY_mat+alpha*eye(mem))\eye(size(YTY_mat)));
Uhat_mat = [U_mat, S_mat];

Vtilde_mat = [del*(.5*U_mat*YTY_mat-YTY_mat), U_mat];
Vhat_mat = [S_mat-U_mat*STY_mat', U_mat];

Ztilde_mat = eye(2*mem)+(1/del)*Vtilde_mat'*Vtilde_mat;
Ztildeinv_mat=inv(Ztilde_mat);
H0hat = inv(del*V_mat'*problem);
H0hatinv_mat = 1/del*speye(K) - 1/(del^2)*Vtilde_mat*Ztildeinv_mat*Vtilde_mat';


% Hhat0inv_mat:


