%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    fdSY_mat.m
%                   Russell Luke
%               Department of MathSci
%              University of Delaware  
%                  April 12, 2008 
%
%
%
%
% DESCRIPTION:  TO DO
% 
%  finite difference history ordering for limited memory matrix secant
%  methods
%
% INPUT:
%     K, mem:  dimension of incoming arrays
%     x_mat, the matrix of iterates
%     gradf_mat, the matrix of gradients
%
% OUTPUT:
%        
%     S_mat, Y_mat
%
% USAGE: 
%
%       [S_mat,Y_mat] = fdSY_mat(K,mem,x_mat,gradf_mat)
% 
% SUBROUTINE CALLS:
%      einen.m
%      

function [S_mat,Y_mat] = fdSY_mat(K,mem,x_mat,gradf_mat)

% disp('K')
% disp(K)
% disp('mem')
% disp(mem)
% disp('x_mat')
% disp(x_mat)
% disp('gradf_mat')
% disp(gradf_mat)
tmp_vec = einen(1,mem-1,x_mat(1,1:mem-1));
% disp('tmp_vec')
% disp(tmp_vec)
tmp_mat = x_mat(1:K,mem)*tmp_vec;
% disp('x_mat(1:K, mem) =')
% disp(x_mat(1:K, mem))
% disp('tmp_mat =')
% disp(tmp_mat)
S_mat   = x_mat(1:K,1:mem-1)- tmp_mat;
% disp('S_mat')
% disp(S_mat)
tmp_mat = gradf_mat(1:K,mem)*tmp_vec;
% disp('tmp_mat')
% disp(tmp_mat)
Y_mat   = gradf_mat(1:K,1:mem-1) - tmp_mat;
% disp('Y_mat')
% disp(Y_mat)
