from numpy import array, dot, zeros
from numpy.linalg import norm


def Burke_func(x):
    # y is a mapping from R7 into R8
    y = zeros(8)
    y[0] = 105 - 4*x[0] - 5*x[1] + 3*x[6]**2
    y[1] = -10*x[0] + 8*x[2] + x[6]
    y[2] = 8*x[0] - 2*x[1] + 12*x[4] - 5
    y[3] = -3*(x[0]-2)**2 - 4*(x[1]-3)**2 - 2*x[2]**2 + 7*x[3] + 100
    y[4] = -5*x[0]**2 - 8*x[1] - (x[2]-6)**2 + 2*x[3] + 40
    y[5] = -.5*(x[0]-8)**2 - 2*(x[1]-4)**2 - 3*x[4]**2 + x[5] + 30
    y[6] = -x[0]**2 - 2*(x[1]-2)**2 + 2*x[0]*x[1] - 14*x[4] + 6*x[5]
    y[7] = 3*x[0] - 6*x[1] - 12*x[4]*x[5]

    # f is a mapping from R8 to R1.
    f = .5*norm(y)**2

    # Jacobian of y:
    Jy = array([[-4., -5., 0., 0., 0., 0., 6.*x[6]],
                [-10., 0., 8., 0., 0., 0., 1.],
                [8., -2., 0., 0., 12., 0., 0.],
                [-6.*(x[0]-2.), -8.*(x[1]-3.), -4.*x[2], 7., 0., 0., 0.],
                [-10.*x[0], -8., -2.*(x[2]-6.), 2., 0., 0., 0.],
                [-(x[0]-8.), -4.*(x[1]-4.), 0., 0., -6.*x[4], 1., 0.],
                [-2.*x[0]+2.*x[1], -4.*(x[1]-2.)+2.*x[0], 0., 0., -14., 6., 0.],
                [3., -6., 0., 0., -12.*x[5], -12.*x[4], 0.]])

    # The gradien of f is then...
    Jf = dot(Jy.T, y)

    return f, Jf
